<template>
  <div class="home">
    <Logo />
    <NavRibbon />
    <main id="home">
      <HeroHeader />

      <ContentWindow id="item" :drag="this.active" v-if="false" />
      <PostCard id="item" :drag="this.active" v-if="true" />
    </main>
    <TheFooter />
  </div>
</template>


<script>
import NavRibbon from "../components/TheNavRibbon.vue";
import Logo from "../components/TheLogo.vue";
import HeroHeader from "../components/HeroHeader.vue";
import ContentWindow from "../components/ContentWindow.vue";
//import PostCard from "../components/ThePostcard.vue";
import TheFooter from "../components/TheFooter.vue";

export default {
  name: "HomeView",
  components: {
    Logo,
    NavRibbon,
    HeroHeader,
    ContentWindow,
    //PostCard,
    TheFooter,
  },
  data() {
    return {
      dragItem: null,
      container: null,

      dragHandle: null,

      active: false,
      currentX: 0,
      currentY: 0,
      initialX: 0,
      initialY: 0,
      xOffset: 0,
      yOffset: 0,
    };
  },
  mounted() {
    this.dragHandle = document.getElementById("drag-window");
    this.dragItem = document.getElementById("item");
    this.container = document.getElementById("container");

    this.container.addEventListener("touchstart", this.dragStart, false);
    this.container.addEventListener("touchend", this.dragEnd, false);
    this.container.addEventListener("touchmove", this.drag, false);

    this.container.addEventListener("mousedown", this.dragStart, false);
    this.container.addEventListener("mouseup", this.dragEnd, false);
    this.container.addEventListener("mousemove", this.drag, false);
  },

  methods: {
    dragStart(e) {
      if (e.type === "touchstart") {
        this.initialX = e.touches[0].clientX - this.xOffset;
        this.initialY = e.touches[0].clientY - this.yOffset;
      } else {
        this.initialX = e.clientX - this.xOffset;
        this.initialY = e.clientY - this.yOffset;
      }

      if (e.target === this.dragHandle) {
        this.active = true;
      }
    },

    dragEnd() {
      this.initialX = this.currentX;
      this.initialY = this.currentY;

      this.active = false;
    },

    drag(e) {
      if (this.active) {
        e.preventDefault();

        if (e.type === "touchmove") {
          this.currentX = e.touches[0].clientX - this.initialX;
          this.currentY = e.touches[0].clientY - this.initialY;
        } else {
          this.currentX = e.clientX - this.initialX;
          this.currentY = e.clientY - this.initialY;
        }

        this.xOffset = this.currentX;
        this.yOffset = this.currentY;

        this.setTranslate(this.currentX, this.currentY, this.dragItem);
      }
    },

    setTranslate(xPos, yPos, el) {
      el.style.transform = "translate3d(" + xPos + "px, " + yPos + "px, 0)";
    },
  },
};
</script>
